function    [Q,R,P] = QR_alg(X)
%
%   function    [Q,R,P] = QR_alg(X)
%   =============================
%
%   X is linear independent set
%
%   Q is orthogonal
%   R is upper triangular
%

%   (c) 2006 by Tomas Co
%   @ Michigan Technological University

%    if det(X'*X)==0
%        disp('--Error: X columns not independent')
%    end
    
%    if nargout>2, permute=true; else permute=false; end
    [N,M]           = size(X)                   ;
    P=1:M;
    R               = []                        ;
    Q               = []                        ;
    z               = []                        ;
    for i=1:M
%        if permute
%            H=X(:,i:end);
%            pp=P(i:end);
%            W=sum(H.*H);
%            [im,ip]=sort(W,'descend');
%            X(:,i:end)=H(:,ip);
%            P(i:end)=pp(ip);
%        end
        x           = X(:,i)                    ;
        alpha       = norm(x)                   ;
        q           = x/alpha                   ;
        if i<M
            rk              = q'*X(:,i+1:end)   ;
            X(:,i+1:end)    = X(:,i+1:end)-q*rk ;
            R               = [R;[z,alpha,rk]]  ;
            z               = [z,0]             ;    
        else
            R               = [R;[z,alpha]]     ;
        end
        Q           = [Q,q]                     ;
    end