function [x,y,tri] = circle_arc_mesh(radius,th1,th2,dL)
%
% function [x,y,tri] = circle_arc_mesh(radius,th1,th2,dL)
% =================================================
%   
%   triangulates a circular are section 
%       radius = maximum radius
%       th1, th2 = angles 1 and 2
%       dL = characteristic length of elements

%   (c) 2011 by Tomas Co
%   Michigan Technological University

    nr = ceil(radius/(0.99*dL)) ;
    rads = linspace(0,radius,nr);
    x = [0];
    y = [0];
    rads(1) = []                                   ;
    for r = rads
        nth     = ceil((th2-th1)*r/(0.99*dL))       ;
        nth     = max(nth,3) ;
        theta   = linspace(th1,th2,nth)            ;
        x       = [x,r*cos(theta)];
        y       = [y,r*sin(theta)];
    end
    tri     = delaunay(x,y)                        ;