function draw_ternary(dx,A,B,C)
%
%   draw_ternary(dx,A,B,C)
%   draw_ternary(A,B,C)
%   draw_ternary(dx)
%   ======================
%
%   function to draw the terneray diagram plot axes
%   where,
%       dx = grid interval
%       A, B, C = string, names of components

%   (c) 2003 by Tomas Co
%   @ Michigan Technological University
%

if nargin==1
    A='\bfA';
    B='\bfB';
    C='\bfC';
end
if nargin==3 & isstr(dx)
    C=B;
    B=A;
    A=dx;
    dx=0.1;
end
clf
hold on
cc=[0.7 0.7 0.7];
for i=0:dx:1-dx
   [x1,y1]=getPoints_ternary(i,0);
   [x2,y2]=getPoints_ternary(i,1-i);
   [x3,y3]=getPoints_ternary(0,i);
   [x4,y4]=getPoints_ternary(1-i,i);
   if i~=1 & i~=0,
    text(x4,-0.05,num2str(i),...
       'HorizontalAlignment','right',...
       'Rotation',60);
    text(x1-0.01,y1+0.02,num2str(i),...
       'HorizontalAlignment','right',...
       'Rotation',-60);
    text(x3+0.02,y3,num2str(1-i));
    plot([x1,x2],[y1,y2],'color',cc)
    plot([x3,x4],[y3,y4],'color',cc)
    plot([x1,x3],[y1,y3],'color',cc)
   else
    plot([x1,x2],[y1,y2],'k')
    plot([x3,x4],[y3,y4],'k')
    plot([x1,x3],[y1,y3],'k')
   end
end
plot([0 1],[0 0],'k')
text(0.5,1.8,C,...
       'FontSize',12,...
       'FontName','TimesRoman',...
       'HorizontalAlignment','center');
text(-0.01,-0.02,A,...
       'FontSize',12,...
       'FontName','TimesRoman',...
       'HorizontalAlignment','right');
text(1.01,-0.02,B,...
       'FontSize',12,...
       'FontName','TimesRoman',...
       'HorizontalAlignment','left');
hold off
axis('square')
axis off