function  x  =  findallzeros( fhandle, xguess, maxroots)
%
%    x = findallzeros(fhandle, xguess, maxroots)
%   ============================================
%
%   attemps to find multiple roots of a function.
%
%  fhandle = user defined functions
%
%  xguess = initial guesses
%           ( = 0   if not supplied )
%  maxroots = the number of roots needed
%           ( = 1   if not supplied )

%   (c) 2005,2012 by Tomas Co
%   @ Michigan Technological University

    x   = [ ]                ;
    
    if nargin==1
        xguess =0;
        maxroots = 1;
    end
    lg = length(xguess);
    if length(xguess)<maxroots
        xguess=[xguess,xguess(1)*(1:maxroots-lg)];
    end
    
    for i=1:maxroots
        xg = xguess(i) + 0.01;%*rand();
        if  abs(newf(xg,fhandle))<=1e-16,
            xroot=xg;
        else
            [xroot,val,flag] = fzero(@newf,xg,[],fhandle,x);
            if flag <= 0
                return
            end
        end
        x=[x,xroot];
    end
    
    function f = newf(x,fhandle,oldroots)
    %
    %  supply your own functions here
    %
        f = feval(fhandle,x);
        if (nargin>2)
            if ~isempty(oldroots)
                f = f / polyval( poly(oldroots), x );
            end
        end