function [P,R,v]=matrixreduce(A)
%
% function [P,R,v]=matrixreduce(A)
% ================================
%   
%     P = permutation matrix 
%     R = P A P' is block lower triangular
%     v = vector containing number of connected
%         elements for each row in R
%     ( Note: result for A is a sparse matrix )

%       (c) 2010 by Tomas Co
%       @ Michigan Technological University
        
        n = size(A,1)                   ;
        A = sparse(A)                   ;
        B = logical(A)                  ;
        G = logical(speye(n))           ;
        B = G|B                         ;
        H = B                           ;
        k = 1 ;
        while any(any(G~=H))
            G = H                       ;
            H = bprod(G,B)              ;
            k = k + 1 ;
        end
        full(H)
        ss =  sum(H')                   ;  
        [v,P] = sort(full(ss));
        R = A(P,P)                      ;
        
   function z = bprod(A,B)
     n = size(A,1)                      ;
     z = []                             ;
     for i=1:n
         v = A(i,:)                     ;
         if sum(v)>1
             v = any(B(v,:))            ;
         else
             v = B(v,:)                 ;
         end
         z  = [z;v]                     ;
     end
     z = logical(z)                     ;