xrange  = linspace(0,1,21)                  ;
yrange  = linspace(0,1,21)                  ;
zrange  = linspace(0,1,11)                  ;

[x,y] = meshgrid(xrange, yrange)            ;

k=0;
zrange(1)=[];
zrange(end)=[];
for z = zrange
    
    u = exp(-2*(z-x).^2-5*(1-0.8*z-y).^2)    ;
    
        k=k+1;
        subplot(3,3,k,'fontsize',8);
        surfl(x,y,u);
        text(0,0,1.9,['z= ',num2str(z)]);
        shading interp
        colormap gray
        axis([0 1 0 1 0 1]);
end

    
shg

nxrange = linspace(0,1,21);
nyrange = linspace(0,1,21);
nzrange = linspace(0,1,21);

nxrange(end)=[];
nxrange(1)=[];
nyrange(end)=[];
nyrange(1)=[];
nzrange(end)=[];
nzrange(1)=[];

dx=nxrange(2)-nxrange(1);
dy=nyrange(2)-nyrange(1);
dz=nzrange(2)-nzrange(1);

xsize = length(nxrange);
ysize = length(nyrange);
zsize = length(nzrange);

[ny,nx,nz] = meshgrid(nyrange, nxrange, nzrange);

q1 = 2*(nz - nx).^2;
q2 = 5*(1-4/5*nz - ny).^2;
q = exp(-(q1+q2));
f = -122/5 + 16*(nx-nz).^2 + 100*(1-4/5*nz-ny).^2 ...
    + (8-52/5*nz-8*ny+4*nx).^2;
g = q.*f;
g = sparse(flatten(g));

[nnz,nny]   = meshgrid(nzrange,nyrange);
alpha0      = exp(-2*nnz.^2-5*(1-0.8*nnz-nny).^2);
alpha0      = [alpha0(:)]';
alpha1      = exp(-2*(1-nnz).^2-5*(1-0.8*nnz-nny).^2);
alpha1      = [alpha1(:)]';

bx          = sparse(xsize,ysize*zsize);
bx(1,:)     = alpha0/dx^2;
bx(end,:)   = alpha1/dx^2;

bv          = [];

for x=nxrange
    beta0   = exp(-2*(x-nzrange).^2-5*(1-4/5*nzrange).^2);
    beta1   = exp(-2*(x-nzrange).^2-16/5*(nzrange).^2);

    gamma0  = exp( -2*x^2 - 5*(1-nyrange).^2);
    gamma1  = exp( -2*(1-x)^2 -5*(1/5-nyrange).^2);
    
    by      = sparse(ysize,zsize);
    by(1,:) = beta0/dy^2;
    by(end,:) = beta1/dy^2;
    
    bz      = sparse(zsize,ysize);
    bz(1,:) = gamma0/dz^2;
    bz(end,:) = gamma1/dz^2;
    
    bvk     = by + bz';
    bvk     = bvk(:);
    
    bv      = [bv ; bvk'];
end

bxyz    = bx + bv;

e       = ones(xsize,1);
Ax      = spdiags([e -2*e e], -1:1, xsize, xsize);
e       = ones(ysize,1);
Ay      = spdiags([e -2*e e], -1:1, ysize, ysize);
e       = ones(zsize,1);
Az      = spdiags([e -2*e e], -1:1, zsize, zsize);
        
BigA = (1/dx^2)*kron(speye(zsize*ysize,zsize*ysize),Ax) + ...
       (1/dy^2)*kron(speye(zsize,zsize),kron(Ay,speye(xsize,xsize))) + ...
       (1/dz^2)*kron(Az,speye(ysize*xsize,ysize*xsize)) ;
   
Bigb = g - bxyz;
Bigb = Bigb(:);

u = BigA\Bigb;

u = full(u);
u = reshape(u,xsize,ysize,zsize);
u = permute(u,[2 1 3]);

[nx,ny,nz] = meshgrid(nxrange, nyrange, nzrange);

for q=1:9
    px = nx(:,:,2*q);
    py = ny(:,:,2*q);
    pu = u(:,:,2*q);

%   uu = u;
%   uu(1,:)=[];uu(end,:)=[];uu(:,1)=[];uu(:,end)=[];
%   eru = uu-nu; 
   subplot(3,3,q);
   hold on
   plot3(px,py,pu+1.5e-3,'ok','linewidth',0.1,'markersize',1,'markerfacecolor','black'); 
   hold off

end

figure(2)
for q=1:9
    px = nx(:,:,2*q);
    py = ny(:,:,2*q);
    pu = u(:,:,2*q);

    pz = 2*q*dz;
    uexact = exp(-2*(pz-px).^2-5*(1-0.8*pz-py).^2);
    eru = uexact-pu;    

    subplot(3,3,q,'fontsize',8);
    plot3(px,py,eru,'ok','linewidth',0.1,'markersize',1,'markerfacecolor','black');
    axis([0 1 0 1 -2e-3 2e-3]);
    text(0,0,6e-3,['z= ',num2str(pz)]);

end
%   