function   [x,y,Ind] = rectangle_mesh(x0,y0,X,Y,Nx,Ny)
%
% function   [x,y,Ind] = rectangle_mesh(x0,y0,X,Y,Nx,Ny)
% ======================================================
%
%   creates a rectangular mesh
%       x0,y0 = southwest point of rectangle
%       X,Y = northeast point of rectangle
%       Nx,Ny = number of horizontal and vertical points
%
    xr = linspace(x0,X,Nx);
    yr = linspace(y0,Y,Ny);
    dx = (xr(2)-xr(1))/2;
    dy = (yr(2)-yr(1))/2;
    d  = min(dx,dy);
    [x,y] = meshgrid(xr,yr);
    x = x(:)';
    y = y(:)';
    x = [x,x0+d,x0+d,X-d,X-d];
    y = [y,y0+d,Y-d,y0+d,Y-d];
    Ind = delaunay(x,y);