function [x,y,tri] = simple_rect_mesh(x0,y0,x1,y1,dL)
%
% function [x,y,tri] = simple_rect_mesh(x0,y0,x1,y1,dL)
% =====================================================
%   
%   triangulates a simple rectangle section 
%       x0,y0 = SW corner
%       x1,y1 = NE corner
%       dL = characteristic length of elements

%   (c) 2011 by Tomas Co
%   Michigan Technological University

    if x0>x1,
        xt = x1;
        x1 = x0;
        x0 = xt;
    end
    if y0>y1,
        yt = y1;
        y1 = y0;
        y0 = yt;
    end
    x = [];
    y = [];
    nx = ceil( (x1-x0)/(0.99*dL)) ;
    ny = ceil( (y1-y0)/(0.99*dL)) ;
    xs = linspace(x0,x1,nx);
    ys = linspace(y0,y1,ny);
    for xx = xs
        for yy = ys
            x       = [x,xx]             ;
            y       = [y,yy]             ;
        end
    end
    tri     = delaunay(x,y)              ;