function    v = thomas(a,b,c,v)
%
% function    x = thomas(a,b,c,v)
% ===============================
%
%   Use Thomas algorithm to solve Ax = v
%   where A is tridiagonal with
%     a = vector of main diagonal
%     b = vector of level 1 upper diagonal 
%     c = vector of level 1 lower diagonal

    n = length(a);
    zz = a(1);
    for k=2:n
        zz = a(k)-(b(k-1)*c(k-1))/zz;
        a(k) = zz;
    end
    yy = v(1)/a(1);
    v(1) = yy;
    for k=2:n
        yy = (v(k)-c(k-1)*yy)/a(k);
        v(k) = yy;
    end
    xx = v(n);
    for k=n-1:-1:1
        xx = v(k)-b(k)*xx/a(k);
        v(k) = xx;
    end